import MerklingSession from './merklingSession';
import { ICid } from './domain';
declare type ProxyKey = string | symbol | number;
export declare enum MerklingLifecycleState {
    DIRTY = "DIRTY",
    CLEAN = "CLEAN",
    UNLOADED = "UNLOADED"
}
export declare enum MerklingProxyType {
    IPLD = "IPLD",
    INTERNAL = "INTERNAL"
}
export interface IMerklingProxyRef {
    internalId: number;
    type: MerklingProxyType;
    path: ProxyKey[];
}
export interface IMerklingProxyState {
    ref: MerklingProxyRef;
    session: MerklingSession;
}
export interface IMerklingInternalRecord {
    internalId: number;
    type: MerklingProxyType;
    lifecycleState: MerklingLifecycleState;
    cid: ICid | null;
    state: any;
}
export declare class MerklingProxyRef implements IMerklingProxyRef {
    internalId: number;
    type: MerklingProxyType;
    path: (string | number | symbol)[];
    constructor(ref: IMerklingProxyRef);
    isRef(): boolean;
    toString(): string;
}
export declare const merklingProxyHandler: ProxyHandler<IMerklingProxyState>;
export {};
